PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | Static Protected Attributes | List of all members
PXMLRPCStructBase Class Reference

`#include <pxmlrpc.h>`

Inheritance diagram for PXMLRPCStructBase:
[legend]
Collaboration diagram for PXMLRPCStructBase:
[legend]

## Public Member Functions
void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
PINDEX | GetNumVariables () const
PXMLRPCVariableBase & | GetVariable (PINDEX idx) const
PXMLRPCVariableBase * | GetVariable (const char *name) const
void | AddVariable (PXMLRPCVariableBase *var)
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions
static PXMLRPCStructBase & | GetInitialiser ()
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Protected Member Functions
| PXMLRPCStructBase ()
PXMLRPCStructBase & | operator= (const PXMLRPCStructBase &)
void | EndConstructor ()
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Protected Attributes
PArray< PXMLRPCVariableBase > | variablesByOrder
PDictionary< PString, PXMLRPCVariableBase > | variablesByName
PXMLRPCStructBase * | initialiserStack
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Static Protected Attributes
static PMutex | initialiserMutex
static PXMLRPCStructBase * | initialiserInstance

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Friends inherited from PObject

## Constructor & Destructor Documentation

PXMLRPCStructBase::PXMLRPCStructBase | ( |  | ) |
| protected

## Member Function Documentation

void PXMLRPCStructBase::AddVariable | ( | PXMLRPCVariableBase * | var | ) |

void PXMLRPCStructBase::EndConstructor | ( |  | ) |
| protected

static PXMLRPCStructBase& PXMLRPCStructBase::GetInitialiser | ( |  | ) |
| static

PINDEX PXMLRPCStructBase::GetNumVariables | ( |  | ) | const
| inline

References PArrayObjects::GetSize(), and variablesByOrder.

PXMLRPCVariableBase& PXMLRPCStructBase::GetVariable | ( | PINDEX | idx | ) | const
| inline

References variablesByOrder.

PXMLRPCVariableBase* PXMLRPCStructBase::GetVariable | ( | const char * | name | ) | const
| inline

References PDictionary< K, D >::GetAt(), and variablesByName.

PXMLRPCStructBase& PXMLRPCStructBase::operator= | ( | const PXMLRPCStructBase & |  | ) |
| protected

void PXMLRPCStructBase::PrintOn | ( | ostream & | strm | ) | const
| virtual

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Reimplemented from PObject.

## Member Data Documentation

PXMLRPCStructBase* PXMLRPCStructBase::initialiserInstance
| static protected

PMutex PXMLRPCStructBase::initialiserMutex
| static protected

PXMLRPCStructBase* PXMLRPCStructBase::initialiserStack
| protected

PDictionary<PString, PXMLRPCVariableBase> PXMLRPCStructBase::variablesByName
| protected

Referenced by GetVariable().

PArray<PXMLRPCVariableBase> PXMLRPCStructBase::variablesByOrder
| protected

Referenced by GetNumVariables(), and GetVariable().

The documentation for this class was generated from the following file:

- pxmlrpc.h